summaryrefslogtreecommitdiff
path: root/tests/tail-2/retry.sh
diff options
context:
space:
mode:
Diffstat (limited to 'tests/tail-2/retry.sh')
-rwxr-xr-xtests/tail-2/retry.sh23
1 files changed, 15 insertions, 8 deletions
diff --git a/tests/tail-2/retry.sh b/tests/tail-2/retry.sh
index 4f8422520..97bd6d3d4 100755
--- a/tests/tail-2/retry.sh
+++ b/tests/tail-2/retry.sh
@@ -19,6 +19,13 @@
. "${srcdir=.}/tests/init.sh"; path_prepend_ ./src
print_ver_ tail
+# Function to count number of lines from tail
+# while ignoring transient errors due to resource limits
+countlines_ ()
+{
+ grep -Ev 'inotify (resources exhausted|cannot be used)' out | wc -l
+}
+
# Function to check the expected line count in 'out'.
# Called via retry_delay_(). Sleep some time - see retry_delay_() - if the
# line count is still smaller than expected.
@@ -26,20 +33,20 @@ wait4lines_ ()
{
local delay=$1
local elc=$2 # Expected line count.
- [ "$( wc -l < out )" -ge "$elc" ] || { sleep $delay; return 1; }
+ [ "$(countlines_)" -ge "$elc" ] || { sleep $delay; return 1; }
}
# === Test:
# Retry without --follow results in a warning.
touch file
tail --retry file > out 2>&1 || fail=1
-[ $( wc -l < out ) = 1 ] || fail=1
+[ "$(countlines_)" = 1 ] || fail=1
grep -F 'tail: warning: --retry ignored' out || fail=1
# === Test:
# The same with a missing file: expect error message and exit 1.
tail --retry missing > out 2>&1 && fail=1
-[ $( wc -l < out ) = 2 ] || fail=1
+[ "$(countlines_)" = 2 ] || fail=1
grep -F 'tail: warning: --retry ignored' out || fail=1
# === Test:
@@ -53,7 +60,7 @@ retry_delay_ wait4lines_ .1 6 3 || fail=1 # Wait for the expected output.
kill $pid
wait $pid
# Expect 3 lines in the output file.
-[ $( wc -l < out ) = 3 ] || { fail=1; cat out; }
+[ "$(countlines_)" = 3 ] || { fail=1; cat out; }
grep -F 'cannot open' out || { fail=1; cat out; }
grep -F 'has appeared' out || { fail=1; cat out; }
grep '^X$' out || { fail=1; cat out; }
@@ -69,7 +76,7 @@ retry_delay_ wait4lines_ .1 6 4 || fail=1 # Wait for the expected output.
kill $pid
wait $pid
# Expect 4 lines in the output file.
-[ $( wc -l < out ) = 4 ] || { fail=1; cat out; }
+[ "$(countlines_)" = 4 ] || { fail=1; cat out; }
grep -F 'retry only effective for the initial open' out \
|| { fail=1; cat out; }
grep -F 'cannot open' out || { fail=1; cat out; }
@@ -86,7 +93,7 @@ mkdir missing || fail=1 # Create untailable 'missing'.
retry_delay_ wait4lines_ .1 6 4 || fail=1 # Wait for the expected output.
wait $pid
rc=$?
-[ $( wc -l < out ) = 4 ] || { fail=1; cat out; }
+[ "$(countlines_)" = 4 ] || { fail=1; cat out; }
grep -F 'retry only effective for the initial open' out \
|| { fail=1; cat out; }
grep -F 'cannot open' out || { fail=1; cat out; }
@@ -100,14 +107,14 @@ rm -fd missing out || framework_failure_
# file to appear. Expect 2 lines in the output file ("cannot open" +
# "no files remaining") and exit status 1.
tail --follow=descriptor missing >out 2>&1 && fail=1
-[ $( wc -l < out ) = 2 ] || { fail=1; cat out; }
+[ "$(countlines_)" = 2 ] || { fail=1; cat out; }
grep -F 'cannot open' out || { fail=1; cat out; }
grep -F 'no files remaining' out || { fail=1; cat out; }
# === Test:
# Likewise for --follow=name (without --retry).
tail --follow=name missing >out 2>&1 && fail=1
-[ $( wc -l < out ) = 2 ] || { fail=1; cat out; }
+[ "$(countlines_)" = 2 ] || { fail=1; cat out; }
grep -F 'cannot open' out || { fail=1; cat out; }
grep -F 'no files remaining' out || { fail=1; cat out; }